#include <windows.h>
#include <sql.h>
#include <sqlext.h>
#include <stdio.h>
#include <conio.h>
#include <unistd.h>
#include <errno.h>

SQLHANDLE  environment_handle;
SQLHANDLE  connection_handle;

SQLHANDLE  statement_handle;
SQLRETURN  return_code;

RETCODE display_results();
void mostra_opcoes(void);

#define MAX 255

int main()
{

  SQLCHAR  ODBC_database_name[] = "g091if685ec_eq02";
  SQLCHAR  sql_statement[MAX];
  int opcao;


  return_code = SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &environment_handle);

  if (return_code == SQL_SUCCESS)
    return_code = SQLSetEnvAttr(environment_handle, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)SQL_OV_ODBC3, SQL_IS_UINTEGER);

  if (return_code == SQL_SUCCESS)
    return_code = SQLAllocHandle(SQL_HANDLE_DBC, environment_handle, &connection_handle);

  if (connection_handle != NULL) {
      return_code = SQLConnect(connection_handle, ODBC_database_name, SQL_NTS, (SQLCHAR *) "g091if685ec_eq02",
                                SQL_NTS, (SQLCHAR *) "soifresque", SQL_NTS);

      if ((return_code == SQL_SUCCESS) || (return_code == SQL_SUCCESS_WITH_INFO))
            printf("Conexao bem sucedida com a base de dados %s.\n\n", ODBC_database_name);
      else
            printf("Conexao a base de dados %s falhou.\n", ODBC_database_name);


      return_code = SQLAllocHandle(SQL_HANDLE_STMT, connection_handle, &statement_handle);

    mostra_opcoes();
    opcao = fgetc(stdin);
    printf("\n\n");

      switch(opcao) {
          case '1':
                strcpy((char *) sql_statement, "INSERT INTO tb_atende VALUES('00088','11/02/2007',(select ref (a) from tb_assinante a where a.cpf = '01234567890'),(select ref(f) from tb_funcionario f where f.cpf = '54454545455'))");
                break;

          case '2':
                strcpy((char *) sql_statement, "UPDATE tb_atende SET protocolo = '00006' WHERE protocolo = '00088'");
                break;

          case '3':
                strcpy((char *) sql_statement, "DELETE FROM tb_atende WHERE protocolo = '00006'");
                break;

          case '4':
                strcpy((char *) sql_statement, "SELECT nome FROM tb_revista");
                break;

          default:
                printf("Opcao invalida\n");
                break;
      }

      printf("--- CONSULTA: %s (opcao: %c)\n\n", sql_statement, opcao);
      return_code = SQLPrepare(statement_handle, sql_statement, SQL_NTS);

      return_code = SQLExecute (statement_handle);

      if (return_code == SQL_SUCCESS) {
          if(opcao == 52)                        // so o select retorna na tela
            display_results();
      }
      else
            printf("A consulta NAO foi executada com sucesso: %s\n\n", strerror(errno));

      if (statement_handle != NULL)
            SQLFreeHandle(SQL_HANDLE_STMT, statement_handle);

      return_code = SQLDisconnect(connection_handle);

      SQLFreeHandle(SQL_HANDLE_DBC, connection_handle);
 }


  if (environment_handle != NULL)
    SQLFreeHandle(SQL_HANDLE_ENV, environment_handle);

  printf("Pressione qualquer tecla para sair.");
  fgetc(stdin);


  return(return_code);

}

RETCODE display_results()
{
  RETCODE       return_code;
  SQLCHAR       nome[MAX];
  //SQLCHAR       Cpf[100];

  return_code = SQLBindCol(statement_handle, 1, SQL_C_CHAR, (SQLPOINTER) nome, sizeof(nome), NULL);

//  return_code =
//    SQLBindCol(statement_handle, 2, SQL_C_CHAR,
//	       (SQLPOINTER)Cpf, sizeof(Cpf), NULL);

  printf("Revistas:\n\n");

  return_code = SQLFetch(statement_handle);

  if (return_code == SQL_NO_DATA_FOUND)
        printf("Nenhuma tupla satisfaz a consulta dada.\n");
  else
        printf("      NOME      \n");

    while (return_code != SQL_NO_DATA_FOUND)
      {

	    printf("       %s       \n", nome);
	    return_code = SQLFetch(statement_handle);
      };

  printf("\n");


  return(return_code);
}

void mostra_opcoes(void)
{
    printf("Digite uma opcao para consulta\n");
    printf("------------------------------\n\n");
    printf("1. Inserir\n");
    printf("2. Atualizar\n");
    printf("3. Excluir\n");
    printf("4. Consultar\n\n");

    printf("Opcao: ");
}
